//SWITCH-TO: vue
import { defineComponent } from "vue"
import tools, { type subject_item_t } from "./tools";
import MindEdit from './components/Mind.vue'



export default defineComponent({
    components:{
        MindEdit
    },

    data() {
        return {
            md_content:"",
            edit_type: <"jsmind" | "md_content"> "md_content",
            subject: <subject_item_t> {} ,
        };
    },
    created() {
        this.md_content= `# 中国传统文化艺术之美

## 介绍中国传统文化艺术的丰富内涵和影响

### 传统文化的重要性和价值
#### 传承千年的文化宝藏
中国传统文化是一座千年的宝藏，蕴含着丰富的哲学思想、价值观念和审美情趣。这些传统元素是中华民族独特的文化基因，凝聚了历史的智慧和精髓。
#### 对现代社会的启示和影响
传统文化在现代社会依然具有重要的启示意义。通过对古人的智慧进行深入思考，我们可以找到应对现实问题的新路径。传统文化也是塑造社会共识、凝聚国家认同感的重要纽带。

## 中国传统绘画艺术的魅力

### 国画的独特韵味
#### 水墨意境的表达
水墨意境是国画的灵魂，通过线条、墨色、留白等表现情感与意境。画家在作品中运用“有形无形”的艺术手法，勾勒出深远的意境，引导观者自由想象。

#### 山水、花鸟、人物画的特点
国传统绘画包括山水、花鸟、人物等多种题材。山水画以“山呼万壑赴碧空”表现大自然壮美，花鸟画以“梅兰竹菊”传递深意，人物画以“以形写神”展现人物性格。

### 工笔与写意的艺术表现
#### 工笔画的精细技法
工笔画追求精细写实，要求线条准确、细腻，色彩鲜艳。画家通过层层叠加的颜色和细节描绘，创造出生动逼真的画面，令人陶醉其中。

#### 写意画的意境与自由
写意画强调意境与表现力，画家以自由的笔墨表现内心情感。通过墨点、墨痕、笔法的变化，创造出富有情感和个性的艺术效果，令人感受到画家的创作情趣。

### 画家与作品赏析
#### 吴道子的人物风貌
吴道子以深刻的人物刻画而著称。他通过精湛的线条和丰富的神态表现，勾勒出生动立体的人物形象，展现了人物的性格和情感。

#### 张大千的山水传奇
张大千是一位跨界艺术家，他的山水画作品充满浪漫主义气息。他通过丰富的色彩和大胆的构图，创造出独特的山水意境，赋予作品深厚的情感内涵。

`

    },
    methods: {
        set_jsmind()  {
            this.edit_type="jsmind"
            this.subject= tools.md_to_subject(this.md_content )!;

            this.$nextTick(() => {
                var mind_edit_el = (<HTMLElement>this.get_ref("mind_edit", <any>{}).$el).querySelector(".jsmind-inner");
                mind_edit_el!.scrollLeft = mind_edit_el!.scrollWidth ; //靠右
                //mind_edit_el!.scrollTop = 10000;
            });
        },

        set_md_content() {
            this.edit_type="md_content";
            var subject= this.get_subject_from_jsmind();
            this.md_content=tools.subject_to_md(subject);

        },

        get_ref<T>(ref_id: string, _ref_value: T): Exclude<T, undefined> {
            return (<Exclude<T, undefined>>this.$refs[ref_id]);
        },

        //得到组件里的数据
        get_subject_from_jsmind() {
            return this.get_ref("mind_edit", MindEdit.methods)?.get_subject();
        }

    }
});
