import * as  marked from 'marked';
const md2json = {

    getAlignedContent(mdContent: string) {
        var headings = mdContent.match(/(?:\r\n)#.*$/mg);
        if (!headings) {
            return mdContent.trim();
        }
        for (var i = 0; i < headings.length; i++) {
            var heading = headings[i].trim();
            var propHeading = new RegExp('(?:\r\n){2}' + heading + '.*$', 'mg');
            if (!mdContent.match(propHeading)) {
                var wrongHeading = new RegExp('(?:\r\n)' + heading + '.*$', 'mg');
                mdContent = mdContent.replace(wrongHeading, '\r\n\r\n' + heading);
            }
        }
        return mdContent;
    },
    parse(mdContent: string) {
        var aligned = this.getAlignedContent(mdContent);
        var json = marked.lexer(aligned);
        var currentHeading: any = [];
        var headings: any = [];
        var output = json.reduce((result: any, item: any) => {
            if (!currentHeading) {
                currentHeading = result;
            }
            if (item.type == 'heading') {
                if (!currentHeading || item.depth == 1) {
                    headings = [];
                    result[item.text] = {};
                    currentHeading = result[item.text];
                    headings.push(item.text);
                } else {
                    var parentHeading = this.getParentHeading(headings, item, result);
                    headings = parentHeading.headings;
                    currentHeading = parentHeading.parent;
                    currentHeading[item.text] = {};
                    currentHeading = currentHeading[item.text];
                }
            }
            else {
                currentHeading.raw = currentHeading.raw ? currentHeading.raw + item.raw : item.raw;
            }
            return result;
        }, {});
        return output;
    },

    getParentHeading(headings: any, item: any, result: any) {
        var parent, index = item.depth - 1;
        var currentHeading = headings[index];
        if (currentHeading) {
            headings.splice(index, headings.length - index);
        }
        headings.push(item.text);
        for (var i = 0; i < index; i++) {
            parent = !parent ? result[headings[i]] : parent[headings[i]];
        }
        return {
            headings: headings,
            parent: parent
        };
    },

}
export default md2json;
